Subject: bug#9918: 24.0.90; lazy-highlighting in Info mode

From: Juri Linkov <[email-masked]>
Date: Wed, 02 Nov 2011 01:07:11 +0200

> IIUC, "initial node" just inform the user that the current search is
> failing inside this node (where the search started), but this should
> not be considered an error (like "incomplete input" or "No previous
> search string"), because "initial node", unlike "incomplete input",
> does not deactivate the current Isearch.

If it's not possible to code this situation with the combination
of existing variables `isearch-success' and `isearch-error',
then perhaps we should introduce a new variable `isearch-warning'.

> BTW: while looking for sentences that set the value of `isearch-error'
> inside lisp/isearch.el, I've noticed that some errors begins with an
> uppercase letter ("No previous search string") and others don't
> ("incomplete input").  This should be fixed to make it consistent for
> all error messages.

This is intentional because when you see "No previous search string" the
search string is empty, so the message should look like the beginning of
a new sentence, not like the continuation of a non-empty search string.

> BTW, whatever the patch be, there is a second issue (discovered by
> Drew) that should be addressed:
>
> The first time Isearch is fails inside an Info node, you get the
> "initial node" message, and then, typing another "C-s" have the effect
> of continuing the Isearch across subsequent info nodes.  But this
> behavior sometimes fails.  For example:
>
> 1. Go to Info node "(emacs)Intro".
> 2. Type "C-s extensible C-s C-s".
> --> Here you've got the "initial node" message. OK.
> 3. Type "C-s".
> --> (Observed) The "initial node" message is removed, and everything
> remains the same.  You have to type "C-s" again to continue the search
> in subsequent nodes.
> --> (Expected) The Isearch is continued across subsequent nodes,
> without the need of an extra "C-s".

The current behavior is correct.  When you see the message about failing
Isearch without the "initial node" suffix, that means that it reached
the end of the whole manual and failed completely.  The subsequent `C-s'
starts searching from the beginning of the manual.